clear all; close all; clc,

path(pathdef);

addpath('0_data_A1_A2');
addpath('0_data_A1_A2/210504');

% load neededParameterForBenchmarking.mat
% index_v1 = 16;
% species_engergy = species{2};
% v_energy = str2num(cell2mat(erase(species_engergy(index_v1:index_v1+3),'eV')));
% v_energy = [0 v_energy'];
% 
% %% data from Meas.
% % file_withpath = '0_data_A1_A2/210504/Nv_3kV_200ns.csv';
% % % import time and relative density from each file
% % meas_tn01234 = importfile1(file_withpath);
% % meas_n_ratio = log(meas_tn01234(:,2:end-1)./meas_tn01234(:,3:end));
% % vib_meas_Te = ((v_energy(2:end)-v_energy(1:end-1))*11604)./meas_n_ratio;


%% data from Sim. 
% sp = SimParameters('InputFolder/InputFile.txt');
spp = SimParametersP('InputFolder/InputFile_pulsed.txt');


% -----------------------------a2_simpleForm
% power-on
t_loki_on = str2num(spp.Params.pulse.t_lokiCall);
pon1_multi = [];
pon_multi = [];
for i=1:length(t_loki_on)-1
    filestr_on1 = sprintf('Output_a2_simpleForm/N2Pulsed/Pulseon_1_%d.mat',i);
    filestr_on = sprintf('Output_a2_simpleForm/N2Pulsed/Pulseon_6_%d.mat',i);
    pon1_temp = load(filestr_on1);
    pon_temp = load(filestr_on);
    pon1_temp.sol(:,1) = pon1_temp.sol(:,1)+t_loki_on(i);
    pon_temp.sol(:,1) = pon_temp.sol(:,1)+t_loki_on(i);
    % erase the duplicated point for interplolation
    if i==1
        pon1_multi =[pon1_multi; pon1_temp.sol];
        pon_multi =[pon_multi; pon_temp.sol];
    % erase the duplicated point for interplolation
    else
        pon1_multi =[pon1_multi; pon1_temp.sol(2:end,:)];
        pon_multi =[pon_multi; pon_temp.sol(2:end,:)];
    end
end

% power-off
filestr_off1 = sprintf('Output_a2_simpleForm/N2Pulsed/Pulseoff_1.mat',i);
filestr_off = sprintf('Output_a2_simpleForm/N2Pulsed/Pulseoff_6.mat',i);
poff1_temp = load(filestr_off1);
poff_temp = load(filestr_off);
poff1_multi = poff1_temp.sol(2:end,:);
poff_multi = poff_temp.sol(2:end,:);

% together
poff1_multi(:,1) = poff1_multi(:,1) + pon1_multi(end,1);
den1_multi = [pon1_multi;poff1_multi];
poff_multi(:,1) = poff_multi(:,1) + pon_multi(end,1);
den_multi_a2_simpleForm = [pon_multi;poff_multi];

% -----------------------------b2_SSHpaper1
% power-on
t_loki_on = str2num(spp.Params.pulse.t_lokiCall);
pon1_multi = [];
pon_multi = [];
for i=1:length(t_loki_on)-1
    filestr_on1 = sprintf('Output_b2_SSHpaper1/N2Pulsed/Pulseon_1_%d.mat',i);
    filestr_on = sprintf('Output_b2_SSHpaper1/N2Pulsed/Pulseon_6_%d.mat',i);
    pon1_temp = load(filestr_on1);
    pon_temp = load(filestr_on);
    pon1_temp.sol(:,1) = pon1_temp.sol(:,1)+t_loki_on(i);
    pon_temp.sol(:,1) = pon_temp.sol(:,1)+t_loki_on(i);
    % erase the duplicated point for interplolation
    if i==1
        pon1_multi =[pon1_multi; pon1_temp.sol];
        pon_multi =[pon_multi; pon_temp.sol];
    % erase the duplicated point for interplolation
    else
        pon1_multi =[pon1_multi; pon1_temp.sol(2:end,:)];
        pon_multi =[pon_multi; pon_temp.sol(2:end,:)];
    end
end

% power-off
filestr_off1 = sprintf('Output_b2_SSHpaper1/N2Pulsed/Pulseoff_1.mat',i);
filestr_off = sprintf('Output_b2_SSHpaper1/N2Pulsed/Pulseoff_6.mat',i);
poff1_temp = load(filestr_off1);
poff_temp = load(filestr_off);
poff1_multi = poff1_temp.sol(2:end,:);
poff_multi = poff_temp.sol(2:end,:);

% together
poff1_multi(:,1) = poff1_multi(:,1) + pon1_multi(end,1);
den1_multi = [pon1_multi;poff1_multi];
poff_multi(:,1) = poff_multi(:,1) + pon_multi(end,1);
den_multi_b2_SSHpaper1 = [pon_multi;poff_multi];

% -----------------------------c2_FHO
% power-on
t_loki_on = str2num(spp.Params.pulse.t_lokiCall);
pon1_multi = [];
pon_multi = [];
for i=1:length(t_loki_on)-1
    filestr_on1 = sprintf('Output_c2_FHO/N2Pulsed/Pulseon_1_%d.mat',i);
    filestr_on = sprintf('Output_c2_FHO/N2Pulsed/Pulseon_6_%d.mat',i);
    pon1_temp = load(filestr_on1);
    pon_temp = load(filestr_on);
    pon1_temp.sol(:,1) = pon1_temp.sol(:,1)+t_loki_on(i);
    pon_temp.sol(:,1) = pon_temp.sol(:,1)+t_loki_on(i);
    % erase the duplicated point for interplolation
    if i==1
        pon1_multi =[pon1_multi; pon1_temp.sol];
        pon_multi =[pon_multi; pon_temp.sol];
    % erase the duplicated point for interplolation
    else
        pon1_multi =[pon1_multi; pon1_temp.sol(2:end,:)];
        pon_multi =[pon_multi; pon_temp.sol(2:end,:)];
    end
end

% power-off
filestr_off1 = sprintf('Output_c2_FHO/N2Pulsed/Pulseoff_1.mat',i);
filestr_off = sprintf('Output_c2_FHO/N2Pulsed/Pulseoff_6.mat',i);
poff1_temp = load(filestr_off1);
poff_temp = load(filestr_off);
poff1_multi = poff1_temp.sol(2:end,:);
poff_multi = poff_temp.sol(2:end,:);

% together
poff1_multi(:,1) = poff1_multi(:,1) + pon1_multi(end,1);
den1_multi = [pon1_multi;poff1_multi];
poff_multi(:,1) = poff_multi(:,1) + pon_multi(end,1);
den_multi_c2_FHO = [pon_multi;poff_multi];

%% VDF
figure(1)
% -----------------------------a2_simpleForm
den_multi = den_multi_a2_simpleForm;
VVtype = "sfHO";

subplot(2,3,1)

vib_index = 23:79;
vib = length(vib_index);
t_wish = [1 50 75 250]*1e-9;
t = den_multi(:,1);
n_vib = den_multi(:,vib_index);

% % (1): approach (1) do not shows the value of the exact "t_wish" (just the value most near to it); therefore we give up this approach. 
% linetype = ["k-","r--","b:","m-."];
% index_wish_list = zeros(1,length(t_wish));
% for i=1:length(t_wish)
%     [~,index_wish] = min(abs(t-t_wish(i)));
%     index_wish_list(i)= index_wish;
%     
%     plot(1:vib,n_vib(index_wish_list(i),:),linetype(i),'LineWidth',2)
%     hold on
% end
% ----
% (2): approach (2) do show the value of the exact "t_wish"
n_vib_plot = interp1(t, n_vib, t_wish');
% n_vib_plot =  zeros(length(t_wish),length(vib_index));
% for j=1:length(vib_index)
%     n_vib_plot(:,j) = interp1(t, n_vib(:,j), t_wish');
% end
plot(1:vib,n_vib_plot(1,:),'-','Color','k','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(2,:),'--','Color','r','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(3,:),':','Color','b','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(4,:),'-.','Color',[0 0.5 0],'LineWidth',2)
hold on

lgd2 = legend('1ns','50ns','75ns','250ns')
lgd2.FontSize = 10;
xlim([-5 vib+5])
xticks(0:10:vib+5)
% xlabel('N_2 vibrational level (v)')
set(gca,'xticklabel',[])
ylim([1e10 2e24])
set(gca, 'YScale', 'log')
yticks([1e11 1e15 1e19 1e23])
ylabel('Density (m^{-3})')
grid on
set(gca,'FontSize',15)
% text(0.05,0.1,VVtype,'Units','normalized','Color','k','FontSize',15)
text(0.18,0.9,'power-on','Units','normalized','Color',[0 0.5 0],'FontSize',15)
text(0.05,1.05,VVtype,'Units','normalized','Color','k','FontSize',15)

subplot(2,3,4)

vib_index = 23:79;
vib = length(vib_index);
t_wish = [250 1e3 1e5 1e6]*1e-9;
t = den_multi(:,1);
n_vib = den_multi(:,vib_index);

% % (1): approach (1) do not shows the value of the exact "t_wish" (just the value most near to it); therefore we give up this approach. 
% % linetype = ["k-","r--","b:","m-."];
% linetype = ["m-.","b:","r--","k-"];
% index_wish_list = zeros(1,length(t_wish));
% for i=1:length(t_wish)
%     [~,index_wish] = min(abs(t-t_wish(i)));
%     index_wish_list(i)= index_wish;
%     
%     plot(1:vib,n_vib(index_wish_list(i),:),linetype(i),'LineWidth',2)
%     hold on
% end
% ----
% (2): approach (2) do show the value of the exact "t_wish"
n_vib_plot = interp1(t, n_vib, t_wish');
% n_vib_plot =  zeros(length(t_wish),length(vib_index));
% for j=1:length(vib_index)
%     n_vib_plot(:,j) = interp1(t, n_vib(:,j), t_wish');
% end
plot(1:vib,n_vib_plot(1,:),'-.','Color','[0 0.5 0]','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(2,:),':','Color','b','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(3,:),'--','Color','r','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(4,:),'-','Color','k','LineWidth',2)
hold on

lgd2 = legend('250ns','1x10^3ns','1x10^5ns','1x10^6ns')
lgd2.FontSize = 10;
xlim([-5 vib+5])
xticks(0:10:vib+5)
xlabel('N_2 vibrational level (v)')
% set(gca,'xticklabel',[])
ylim([1e10 2e24])
set(gca, 'YScale', 'log')
yticks([1e11 1e15 1e19 1e23])
ylabel('Density (m^{-3})')
% set(gca,'yticklabel',[])
grid on
set(gca,'FontSize',15)
% text(0.05,0.1,VVtype,'Units','normalized','Color','k','FontSize',15)
text(0.18,0.9,'power-off','Units','normalized','Color','r','FontSize',15)





% -----------------------------b2_SSHpaper1
den_multi = den_multi_b2_SSHpaper1;
VVtype = "SSH";

subplot(2,3,2)

vib_index = 23:79;
vib = length(vib_index);
t_wish = [1 50 75 250]*1e-9;
t = den_multi(:,1);
n_vib = den_multi(:,vib_index);

% % (1): approach (1) do not shows the value of the exact "t_wish" (just the value most near to it); therefore we give up this approach. 
% linetype = ["k-","r--","b:","m-."];
% index_wish_list = zeros(1,length(t_wish));
% for i=1:length(t_wish)
%     [~,index_wish] = min(abs(t-t_wish(i)));
%     index_wish_list(i)= index_wish;
%     
%     plot(1:vib,n_vib(index_wish_list(i),:),linetype(i),'LineWidth',2)
%     hold on
% end
% (2): approach (2) do show the value of the exact "t_wish"
n_vib_plot = interp1(t, n_vib, t_wish');
% n_vib_plot =  zeros(length(t_wish),length(vib_index));
% for j=1:length(vib_index)
%     n_vib_plot(:,j) = interp1(t, n_vib(:,j), t_wish');
% end
plot(1:vib,n_vib_plot(1,:),'-','Color','k','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(2,:),'--','Color','r','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(3,:),':','Color','b','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(4,:),'-.','Color',[0 0.5 0],'LineWidth',2)
hold on

lgd2 = legend('1ns','50ns','75ns','250ns')
lgd2.FontSize = 10;
xlim([-5 vib+5])
xticks(0:10:vib+5)
% xlabel('N_2 vibrational level (v)')
set(gca,'xticklabel',[])
ylim([1e10 2e24])
set(gca, 'YScale', 'log')
yticks([1e11 1e15 1e19 1e23])
% ylabel('Density (m^{-3})')
set(gca,'yticklabel',[])
grid on
set(gca,'FontSize',15)
% text(0.05,0.1,VVtype,'Units','normalized','Color','k','FontSize',15)
text(0.18,0.9,'power-on','Units','normalized','Color',[0 0.5 0],'FontSize',15)
text(0.05,1.05,VVtype,'Units','normalized','Color','k','FontSize',15)

subplot(2,3,5)

vib_index = 23:79;
vib = length(vib_index);
t_wish = [250 1e3 1e5 1e6]*1e-9;
t = den_multi(:,1);
n_vib = den_multi(:,vib_index);

% % (1): approach (1) do not shows the value of the exact "t_wish" (just the value most near to it); therefore we give up this approach. 
% % linetype = ["k-","r--","b:","m-."];
% linetype = ["m-.","b:","r--","k-"];
% index_wish_list = zeros(1,length(t_wish));
% for i=1:length(t_wish)
%     [~,index_wish] = min(abs(t-t_wish(i)));
%     index_wish_list(i)= index_wish;
%     
%     plot(1:vib,n_vib(index_wish_list(i),:),linetype(i),'LineWidth',2)
%     hold on
% end
% ----
% (2): approach (2) do show the value of the exact "t_wish"
n_vib_plot = interp1(t, n_vib, t_wish');
% n_vib_plot =  zeros(length(t_wish),length(vib_index));
% for j=1:length(vib_index)
%     n_vib_plot(:,j) = interp1(t, n_vib(:,j), t_wish');
% end
plot(1:vib,n_vib_plot(1,:),'-.','Color','[0 0.5 0]','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(2,:),':','Color','b','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(3,:),'--','Color','r','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(4,:),'-','Color','k','LineWidth',2)
hold on

lgd2 = legend('250ns','1x10^3ns','1x10^5ns','1x10^6ns')
lgd2.FontSize = 10;
xlim([-5 vib+5])
xticks(0:10:vib+5)
xlabel('N_2 vibrational level (v)')
% set(gca,'xticklabel',[])
ylim([1e10 2e24])
set(gca, 'YScale', 'log')
yticks([1e11 1e15 1e19 1e23])
% ylabel('Density (m^{-3})')
set(gca,'yticklabel',[])
grid on
set(gca,'FontSize',15)
% text(0.05,0.1,VVtype,'Units','normalized','Color','k','FontSize',15)
text(0.18,0.9,'power-off','Units','normalized','Color','r','FontSize',15)





% -----------------------------c2_FHO
den_multi = den_multi_c2_FHO;
VVtype = "FHO";

subplot(2,3,3)

vib_index = 23:79;
vib = length(vib_index);
t_wish = [1 50 75 250]*1e-9;
t = den_multi(:,1);
n_vib = den_multi(:,vib_index);

% % (1): approach (1) do not shows the value of the exact "t_wish" (just the value most near to it); therefore we give up this approach. 
% linetype = ["k-","r--","b:","m-."];
% index_wish_list = zeros(1,length(t_wish));
% for i=1:length(t_wish)
%     [~,index_wish] = min(abs(t-t_wish(i)));
%     index_wish_list(i)= index_wish;
%     
%     plot(1:vib,n_vib(index_wish_list(i),:),linetype(i),'LineWidth',2)
%     hold on
% end
% ----
% (2): approach (2) do show the value of the exact "t_wish"
n_vib_plot = interp1(t, n_vib, t_wish');
% n_vib_plot =  zeros(length(t_wish),length(vib_index));
% for j=1:length(vib_index)
%     n_vib_plot(:,j) = interp1(t, n_vib(:,j), t_wish');
% end
plot(1:vib,n_vib_plot(1,:),'-','Color','k','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(2,:),'--','Color','r','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(3,:),':','Color','b','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(4,:),'-.','Color',[0 0.5 0],'LineWidth',2)
hold on

lgd2 = legend('1ns','50ns','75ns','250ns')
lgd2.FontSize = 10;
xlim([-5 vib+5])
xticks(0:10:vib+5)
% xlabel('N_2 vibrational level (v)')
set(gca,'xticklabel',[])
ylim([1e10 2e24])
set(gca, 'YScale', 'log')
yticks([1e11 1e15 1e19 1e23])
% ylabel('Density (m^{-3})')
set(gca,'yticklabel',[])
grid on
set(gca,'FontSize',15)
% text(0.05,0.1,VVtype,'Units','normalized','Color','k','FontSize',15)
text(0.18,0.9,'power-on','Units','normalized','Color',[0 0.5 0],'FontSize',15)
text(0.05,1.05,VVtype,'Units','normalized','Color','k','FontSize',15)

subplot(2,3,6)

vib_index = 23:79;
vib = length(vib_index);
t_wish = [250 1e3 1e5 1e6]*1e-9;
t = den_multi(:,1);
n_vib = den_multi(:,vib_index);

% % (1): approach (1) do not shows the value of the exact "t_wish" (just the value most near to it); therefore we give up this approach. 
% % linetype = ["k-","r--","b:","m-."];
% linetype = ["m-.","b:","r--","k-"];
% index_wish_list = zeros(1,length(t_wish));
% for i=1:length(t_wish)
%     [~,index_wish] = min(abs(t-t_wish(i)));
%     index_wish_list(i)= index_wish;
%     
%     plot(1:vib,n_vib(index_wish_list(i),:),linetype(i),'LineWidth',2)
%     hold on
% end
% ----
% (2): approach (2) do show the value of the exact "t_wish"
n_vib_plot = interp1(t, n_vib, t_wish');
% n_vib_plot =  zeros(length(t_wish),length(vib_index));
% for j=1:length(vib_index)
%     n_vib_plot(:,j) = interp1(t, n_vib(:,j), t_wish');
% end
plot(1:vib,n_vib_plot(1,:),'-.','Color','[0 0.5 0]','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(2,:),':','Color','b','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(3,:),'--','Color','r','LineWidth',2)
hold on
plot(1:vib,n_vib_plot(4,:),'-','Color','k','LineWidth',2)
hold on

lgd2 = legend('250ns','1x10^3ns','1x10^5ns','1x10^6ns')
lgd2.FontSize = 10;
xlim([-5 vib+5])
xticks(0:10:vib+5)
xlabel('N_2 vibrational level (v)')
% set(gca,'xticklabel',[])
ylim([1e10 2e24])
set(gca, 'YScale', 'log')
yticks([1e11 1e15 1e19 1e23])
% ylabel('Density (m^{-3})')
set(gca,'yticklabel',[])
grid on
set(gca,'FontSize',15)
% text(0.05,0.1,VVtype,'Units','normalized','Color','k','FontSize',15)
text(0.18,0.9,'power-off','Units','normalized','Color','r','FontSize',15)


% ax = axes('Position', [left bottom width height])
set(subplot(2,3,1), 'Position', [0.10 0.55 0.27 0.40])
set(subplot(2,3,2), 'Position', [0.37 0.55 0.27 0.40])
set(subplot(2,3,3), 'Position', [0.64 0.55 0.27 0.40])

set(subplot(2,3,4), 'Position', [0.10 0.15 0.27 0.40])
set(subplot(2,3,5), 'Position', [0.37 0.15 0.27 0.40])
set(subplot(2,3,6), 'Position', [0.64 0.15 0.27 0.40])

set(gcf,'position',[100,100,1000,500])

% saveas(figure(1),'/home/he/Pictures/paper_2/5_Kuh21_3kv200ns_VDF.jpg');

saveas(figure(1),'5_5_Kuh21_3kv200ns_VDF.jpg');
exportgraphics(figure(1),'5_5_Kuh21_3kv200ns_VDF.pdf','BackgroundColor','none','ContentType','vector');

% set(subplot(3,2,7), 'Position', [0.1 0.1 0.28 0.27])
% set(subplot(3,2,8), 'Position', [0.38 0.1 0.28 0.27])
% set(subplot(3,2,9), 'Position', [0.66 0.1 0.28 0.27])
% 
% set(subplot(3,2,4), 'Position', [0.1 0.37 0.28 0.27])
% set(subplot(3,2,5), 'Position', [0.38 0.37 0.28 0.27])
% set(subplot(3,2,6), 'Position', [0.66 0.37 0.28 0.27])
% 
% set(subplot(3,2,1), 'Position', [0.1 0.64 0.28 0.27])
% set(subplot(3,2,2), 'Position', [0.38 0.64 0.28 0.27])
% % set(subplot(3,2,3), 'Position', [0.66 0.64 0.28 0.27])
% 
% set(gcf,'position',[100,100,1400,1400])
% 
% saveas(figure(1),'/home/he/Pictures/paper_2/5_Kuh21_3kv200ns_VDF.jpg');